image: node:19
build:
  script:
    - npm install --cache .npm --prefer-offline --no-optional --no-fund
    - npm run build
    - npm i -g firebase-tools --cache .npm --prefer-offline --no-optional --no-fund
    - firebase deploy --project revue-avega-test --token $firebase_test_token
  environment:
    name: dev
    url: https://dev.example.com
  artifacts:
    paths:
      - dist
  cache:
    key:
      files: 
        - package-lock.json
    paths:
      - node_modules/
      - .npm/

playwright-test:
  script:
    - npm install @playwright/test 
    - npx playwright install --with-deps
    - PLAYWRIGHT_JUNIT_OUTPUT_NAME=results.xml npx playwright test --reporter=junit
  artifacts:
    when: always
    paths:
      - results.xml
    reports:
      junit: results.xml
  needs: ["build"]
  
deploy-prod:
  script:
    - firebase deploy --project revue-avega --token $firebase_prod_token
  environment:
    name: dev
    #url: https://prod.example.com
  artifacts:
    paths:
      - dist
  cache:
    key:
      files: 
        - package-lock.json
    paths:
      - node_modules/
      - .npm/
  when: manual
  needs: ["playwright-test"]